// Datei Bojen02.c
/* ----------------------------------------------------------
 * In Java unterscheidet man zwischen primitven Typen und
 * Referenztypen. In C gibt es sozusagen "von jedem Typ eine
 * primitive Version und eine Referenz-Version", etwa so:
 *
 * "primitve Version"   "Referenz-Version"
 *  int                  int *
 *  Person               Person *
 * ---------------------------------------------------------- */
#include    <stdio.h> // printf, scanf, sprintf
#include   <stdlib.h> // atof, atoi, atol, rand, malloc
//---------------------------------------------------------------
typedef struct {
   unsigned short jahre;
   unsigned short zentim;
   float          kilo;
} Person;
//---------------------------------------------------------------
void bojeInt(int * adr, char * name) {
   // Gibt die int-Variable *adr als Boje aus.
   printf("|%s|--<%08X>--|%d|\n", name, adr, *adr);
} // bojeInt
//---------------------------------------------------------------
void bojeIntAdr(int * * adr, char * name) {
   // Gibt die int*-Variable *adr als Boje aus.
   printf("|%s|--<%08X>--|<%08X>|--|%d|\n",
         name, adr, *adr, **adr);
} // bojeIntAdr
//---------------------------------------------------------------
void bojePerson(Person * adr, char * name) {
   // Gibt die Person-Variable *adr als Boje aus.
   printf("|%s|-----<%08X>\n", name, adr);
   printf("   |jahre |-<%08X>-|%3d|\n", &(adr->jahre),  adr->jahre);
   printf("   |zentim|-<%08X>-|%3d|\n", &(adr->zentim), adr->zentim);
   printf("   |kilo  |-<%08X>-|%3d|\n", &(adr->kilo),   adr->kilo);
} // bojePerson
//---------------------------------------------------------------
#define B13 "             " // 13 Blanks
void bojePersonAdr(Person * * adr, char * name) {
   // Gibt die Person*-Variable *adr als Boje aus:
   Person * adr1 = *adr;
   printf("|%s|--<%08X>--|<%08X>|\n", name, adr, *adr);
   printf(B13 "|jahre |-<%08X>-|%3d|\n", &(adr1->jahre),  adr1->jahre);
   printf(B13 "|zentim|-<%08X>-|%3d|\n", &(adr1->zentim), adr1->zentim);
   printf(B13 "|kilo  |-<%08X>-|%3d|\n", &(adr1->kilo),   adr1->kilo);
} // bojePersonAdr
//---------------------------------------------------------------
int main() {
   int      anna  = 17;
   int    * bert  = (int *) malloc(sizeof(int));
   *bert          =  25;

   Person   carl  = {19, 175, 72};
   Person * dora  = (Person *) malloc(sizeof(Person));
   (*dora).jahre  =  23;   // oder: dora->jahre  =  23;
   (*dora).zentim = 178;   // oder: dora->zentim = 178;
   (*dora).kilo   =  75;   // oder: dora->kilo   =  75;

   printf("Bojen02: Jetzt geht es los!\n");
   printf("------------------------------------------\n");
   bojeInt      (&anna, " anna");
   bojeInt      ( bert, "*bert");
   bojeIntAdr   (&bert, " bert");
   printf("------------------------------------------\n");
   bojePerson   (&carl, " carl");
   bojePerson   ( dora, "*dora");
   bojePersonAdr(&dora, " dora");
   printf("------------------------------------------\n");
   printf("Bojen02: Das war's erstmal!\n");
   return 0;
} // main
/* ----------------------------------------------------------
Ausgabe des Programms Bojen02:

Bojen02: Jetzt geht es los!
------------------------------------------
| anna|--<0022FEEC>--|17|
|*bert|--<0A040418>--|25|
| bert|--<0022FEE8>--|<0A040418>|--|25|
------------------------------------------
| carl|-----<0022FEE0>
   |jahre |-<0022FEE0>-| 19|
   |zentim|-<0022FEE2>-|175|
   |kilo  |-<0022FEE4>-|  0|
|*dora|-----<0A040428>
   |jahre |-<0A040428>-| 23|
   |zentim|-<0A04042A>-|178|
   |kilo  |-<0A04042C>-|  0|
| dora|--<0022FEDC>--|<0A040428>|
             |jahre |-<0A040428>-| 23|
             |zentim|-<0A04042A>-|178|
             |kilo  |-<0A04042C>-|  0|
------------------------------------------
Bojen02: Das war's erstmal!
---------------------------------------------------------- */
