// Datei Bojen03.c
/* ----------------------------------------------------------
 * Reihungen haben grosse Aehnlichkeit mit konstanten Adressen.
 * ---------------------------------------------------------- */
#include    <stdio.h> // printf, scanf, sprintf
#include   <stdlib.h> // atof, atoi, atol, rand, malloc

#define LEN1 3
#define LEN2 5
// ---------------------------------------------------------------------
void drucke01(int ir[], int len) {
   // Verlaesst sich darauf, dass ir eine int-Reihung der Laenge len
   // bezeichnet. Gibt diese Reihung in lesbarer Form aus.
   int i;
   printf("drucke01: Eine Reihung mit %d Komponenten: ", len);
   for (i=0; i<len; i++) {
      printf("%d ", ir[i]);
   }
   printf("\n");
} // drucke01
// ---------------------------------------------------------------------
void drucke02(int * const ia, int len) {
   // Verlaesst sich darauf, dass ia die Adresse einer int-Reihung der
   // Laenge len ist. Gibt diese Reihung in lesbarer Form aus.
   int i;
   printf("drucke02: Eine Reihung mit %d Komponenten: ", len);
   for (i=0; i<len; i++) {
      printf("%d ", ia[i]);
   }
   printf("\n");
} // drucke02
// ---------------------------------------------------------------------
void drucke03(int ir[LEN1]) {
   // Verlaesst sich darauf, dass ir eine int-Reihung der Laenge len
   // bezeichnet. Gibt diese Reihung in lesbarer Form aus.
   int i;
   printf("drucke03: Eine Reihung mit 3 Komponenten: ");
   for (i=0; i<LEN1; i++) {
      printf("%d ", ir[i]);
   }
   printf("\n");
} // drucke03
// ---------------------------------------------------------------------
void drucke04(int * ia, int len) {
   // Verlaesst sich darauf, dass ia die Adresse einer int-Reihung der
   // Laenge len ist. Gibt diese Reihung in lesbarer Form aus.
   int i;
   printf("drucke04: Eine Reihung mit %d Komponenten: ", len);
   for (i=0; i<len; i++) {
      printf("%d ", *ia++);
   }
   printf("\n");
} // drucke04
// ---------------------------------------------------------------------
int main() {

   // Zwei int-Reihungen der Laenge LEN1:
   int         ir01[LEN1] = {11, 12, 13};
   int * const ai01       = (int *) calloc(LEN1, sizeof(int));

   // ir02 und ai02 bezeichnen beide dieselbe int-Reihung
   int         ir02[LEN2] = {31, 32, 33, 34, 35};
   int * const ai02       = ir02;

   // calloc hat ai01 nur mit Nullen initialisiert:
   ai01[0] = 21;
   ai01[1] = 22;
   ai01[2] = 23;

   printf("Bojen03: Jetzt geht es los!\n");
   printf("--------------------------------------------------\n");
   drucke01(ir01, LEN1);
   drucke02(ir01, LEN1);
   drucke03(ir01);
   drucke04(ir01, LEN1);
   printf("--------------------------------------------------\n");
   drucke01(ai01, LEN1);
   drucke02(ai01, LEN1);
   drucke03(ai01);
   drucke04(ai01, LEN1);
   printf("--------------------------------------------------\n");
   drucke03(ir02);
   drucke03(ai02);
   printf("--------------------------------------------------\n");
   printf("Bojen03: Das war's erstmal!\n");
   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms Bojen03:

Bojen03: Jetzt geht es los!
--------------------------------------------------
drucke01: Eine Reihung mit 3 Komponenten: 11 12 13
drucke02: Eine Reihung mit 3 Komponenten: 11 12 13
drucke03: Eine Reihung mit 3 Komponenten: 11 12 13
drucke04: Eine Reihung mit 3 Komponenten: 11 12 13
--------------------------------------------------
drucke01: Eine Reihung mit 3 Komponenten: 21 22 23
drucke02: Eine Reihung mit 3 Komponenten: 21 22 23
drucke03: Eine Reihung mit 3 Komponenten: 21 22 23
drucke04: Eine Reihung mit 3 Komponenten: 21 22 23
--------------------------------------------------
drucke03: Eine Reihung mit 3 Komponenten: 31 32 33
drucke03: Eine Reihung mit 3 Komponenten: 31 32 33
--------------------------------------------------
Bojen03: Das war's erstmal!
------------------------------------------------------------------------ */
