// Datei Bojen06.c
/* ----------------------------------------------------------
 * Eine sinnvolle Anwendung von Variablen der Typen char *,
 * char * * und char * * *: Ein Programm soll bestimmte
 * Meldungen ausgeben, und zwar in einer von mehreren Sprachen
 * (Deutsch oder Englisch). Die Sprache der Meldungen soll
 * leicht aenderbar sein (z.B. durch das Aendern einer einzigen
 * Variablen).
 * ---------------------------------------------------------- */
#include    <stdio.h> // printf, scanf, sprintf
#include   <stdlib.h> // atof, atoi, atol, rand, malloc
//-----------------------------------------------------------
#define ANZ_MELDUNGEN 3
#define ANZ_SPRACHEN  2
#define DE 0 // Sprache Deutsch
#define EN 1 // Sprache Englisch
#define M1 0 // Meldung 1
#define M2 1 // Meldung 2
#define M3 2 // Meldung 3
//-----------------------------------------------------------
// Die einzelnen Meldungen auf Deutsch:
char * m_de_01 = "Bitte geben Sie eine Ganzzahl ein:";
char * m_de_02 = "Ihre Eingabe war nicht zulaessig!";
char * m_de_03 = "Hier ist das Dreifache Ihrer Eingabe:";

// Die einzelnen Meldungen auf Englisch:
char * m_en_01 = "Please enter an integer:";
char * m_en_02 = "Your input was not correct!";
char * m_en_03 = "Here comes your input times three:";

char * * m_de; // Alle Meldungen auf Deutsch
char * * m_en; // Alle Meldungen auf Englisch
char * * m_as; // Alle Meldungen in der aktuellen Sprache

char * * * m;  // Alle Meldungen in allen Sprachen
//-----------------------------------------------------------
void init(void) {
   // Initialisiert alle Adressvariablen.
   m          = (char * * *) malloc(sizeof(char * *) * ANZ_SPRACHEN);
   m_de       = (char * *  ) malloc(sizeof(char *  ) * ANZ_MELDUNGEN);
   m_en       = (char * *  ) malloc(sizeof(char *  ) * ANZ_MELDUNGEN);
   
   *(m_de+M1) = m_de_01;
   *(m_de+M2) = m_de_02;
   *(m_de+M3) = m_de_03;

   *(m_en+M1) = m_en_01;
   *(m_en+M2) = m_en_02;
   *(m_en+M3) = m_en_03;

   *(m+DE)    = m_de;
   *(m+EN)    = m_en;
} // init
//-----------------------------------------------------------
void gibMeldungenInDerAktuellenSpracheAus(void) {
   printf("A %s\n", *(m_as+M1));
   printf("B %s\n", *(m_as+M2));
   printf("C %s\n", *(m_as+M1));
   printf("D %s\n", *(m_as+M3));
} // gibMeldungenInDerAktuellenSpracheAus
//-----------------------------------------------------------
void gibMeldungenInAllenSprachenAus(void) {
   printf("E %s\n", *(*(m+DE)+M1));
   printf("F %s\n", *(*(m+EN)+M1));
   printf("G %s\n", *(*(m+DE)+M3));
   printf("H %s\n", *(*(m+EN)+M3));
} // gibMeldungenInAllenSprachenAus
//-----------------------------------------------------------
void gibAdrVar3Aus(char **** adr, char * name) {
   // Erwartet die Adresse einer char***-Variablen (d.h.
   // einen char****-Wert) und den Namen der Variablen als
   // Parameter. Gibt die betreffende char***-Variable als
   // Boje aus.
   printf("|%-7s|--<%X>--|<%X>|--|<%X>|--|<%X>|--|%c|\n",
           name,   adr,  *adr,  **adr, ***adr, ****adr);
} // gibAdrVar3Aus
//-----------------------------------------------------------
void gibAdrVar2Aus(char *** adr, char * name) {
   // Ebenso wie gibAdrVar3Aus, aber fuer char**-Variablen.
   printf("|%-7s|--<%X>--|<%X>|--|<%X>|--|%c|\n",
           name,   adr,  *adr,  **adr, ***adr);
} // gibAdrVar2Aus
//-----------------------------------------------------------
void gibAdrVar1Aus(char ** adr, char * name) {
   // Ebenso wie gibAdrVar3Aus, aber fuer char*-Variablen.
   printf("|%-7s|--<%X>--|<%X>|--|%c|\n",
           name,   adr,  *adr,  **adr);
} // gibAdrVar1Aus
//-----------------------------------------------------------
void gibAdr3Aus(char *** adr, char * ausdruck) {
   // Erwartet den char***-Wert eines Ausdrucks und den
   // Ausdruck selbst als Parameter. Gibt den Ausdruck,
   // seinen Wert und "alles was daran haengt" aus.
   printf("%-14s: <%X>--|<%X>|--|<%X>|--|%c|\n",
        ausdruck, adr,   *adr,  **adr, ***adr);
} // gibAdr3Aus
//-----------------------------------------------------------
void gibAdr2Aus(char ** adr, char * ausdruck) {
   // Ebenso wie gibAdr3Aus, aber fuer char**-Ausdruecke.
   printf("%-14s: <%X>--|<%X>|--|%c|\n",
        ausdruck, adr,   *adr, **adr);
} // gibAdr2Aus
//-----------------------------------------------------------
void gibAdr1Aus(char * adr, char * ausdruck) {
   // Ebenso wie gibAdr3Aus, aber fuer char*-Ausdruecke.
   printf("%-14s: <%X>--|%c|\n",
        ausdruck, adr,  *adr);
} // gibAdr2Aus
//-----------------------------------------------------------
void gibEinPaarAdressVariablenAus(void) {
   printf("Ein paar Adressvariablen als Bojen dargestellt:\n");
   gibAdrVar3Aus(&m,       "m");
   gibAdrVar2Aus(&m_de,    "m_de");
   gibAdrVar2Aus(&m_en,    "m_en");
   printf("------------------------------------------------\n");
   gibAdrVar1Aus(&m_de_01, "m_de_01");
   gibAdrVar1Aus(&m_de_02, "m_de_02");
   gibAdrVar1Aus(&m_de_03, "m_de_03");
   printf("------------------------------------------------\n");
   gibAdrVar1Aus(&m_en_01, "m_en_01");
   gibAdrVar1Aus(&m_en_02, "m_en_02");
   gibAdrVar1Aus(&m_en_03, "m_en_03");
} // gibEinPaarAdressVariablenAus
//-----------------------------------------------------------
void gibEinPaarAdressAusdrueckeAus(void) {
   printf("Ein paar Adressausdruecke und ihre Werte etc.:\n");
   gibAdr3Aus(m+DE,          "    m+DE");
   gibAdr3Aus(m+EN,          "    m+EN");
   printf("------------------------------------------------\n");
   gibAdr2Aus(*(m+DE)+M1,    "  *(m+DE)+M1");
   gibAdr2Aus(*(m+DE)+M2,    "  *(m+DE)+M2");
   gibAdr2Aus(*(m+DE)+M3,    "  *(m+DE)+M3");
   printf("------------------------------------------------\n");
   gibAdr2Aus(*(m+EN)+M1,    "  *(m+EN)+M1");
   gibAdr2Aus(*(m+EN)+M2,    "  *(m+EN)+M2");
   gibAdr2Aus(*(m+EN)+M3,    "  *(m+EN)+M3");
   printf("------------------------------------------------\n");
   gibAdr1Aus(*(*(m+DE)+M1), "*(*(m+DE)+M1)");
   gibAdr1Aus(*(*(m+DE)+M2), "*(*(m+DE)+M2)");
   gibAdr1Aus(*(*(m+DE)+M3), "*(*(m+DE)+M3)");
   printf("------------------------------------------------\n");
   gibAdr1Aus(*(*(m+EN)+M1), "*(*(m+EN)+M1)");
   gibAdr1Aus(*(*(m+EN)+M2), "*(*(m+EN)+M2)");
   gibAdr1Aus(*(*(m+EN)+M3), "*(*(m+EN)+M3)");
} // gibEinPaarAdressAusdrueckeAus
//-----------------------------------------------------------
int main(void) {
   printf("Bojen06: Jetzt geht es los!\n");
   init();    // Alle Adressvariablen initialisieren
   printf("--------------------------------------------------------\n");
   m_as=m_en; // Englisch zur aktuellen Sprache machen
   gibMeldungenInDerAktuellenSpracheAus();
   printf("--------------------------------------------------------\n");
   m_as=m_de; // Deutsch  zur aktuellen Sprache machen
   gibMeldungenInDerAktuellenSpracheAus();
   printf("--------------------------------------------------------\n");
   gibMeldungenInAllenSprachenAus();
   printf("--------------------------------------------------------\n");
   gibEinPaarAdressVariablenAus();
   printf("--------------------------------------------------------\n");
   gibEinPaarAdressAusdrueckeAus();
   printf("--------------------------------------------------------\n");
   printf("Bojen06: Das war's erstmal!\n");
   return 0;
} // main
/* ----------------------------------------------------------
Ausgabe des Programms Bojen06:

Bojen06: Jetzt geht es los!
--------------------------------------------------------
A Please enter an integer:
B Your input was not correct!
C Please enter an integer:
D Here comes your input times three:
--------------------------------------------------------
A Bitte geben Sie eine Ganzzahl ein:
B Ihre Eingabe war nicht zulaessig!
C Bitte geben Sie eine Ganzzahl ein:
D Hier ist das Dreifache Ihrer Eingabe:
--------------------------------------------------------
E Bitte geben Sie eine Ganzzahl ein:
F Please enter an integer:
G Hier ist das Dreifache Ihrer Eingabe:
H Here comes your input times three:
--------------------------------------------------------
Ein paar Adressvariablen als Bojen dargestellt:
|m      |--<40CA3C>--|<842E64>|--|<842E74>|--|<40A140>|--|B|
|m_de   |--<40CA30>--|<842E74>|--|<40A140>|--|B|
|m_en   |--<40CA34>--|<842E84>|--|<40A1AB>|--|P|
------------------------------------------------
|m_de_01|--<40A128>--|<40A140>|--|B|
|m_de_02|--<40A12C>--|<40A163>|--|I|
|m_de_03|--<40A130>--|<40A185>|--|H|
------------------------------------------------
|m_en_01|--<40A134>--|<40A1AB>|--|P|
|m_en_02|--<40A138>--|<40A1C4>|--|Y|
|m_en_03|--<40A13C>--|<40A1E0>|--|H|
--------------------------------------------------------
Ein paar Adressausdruecke und ihre Werte etc.:
    m+DE      : <842E64>--|<842E74>|--|<40A140>|--|B|
    m+EN      : <842E68>--|<842E84>|--|<40A1AB>|--|P|
------------------------------------------------
  *(m+DE)+M1  : <842E74>--|<40A140>|--|B|
  *(m+DE)+M2  : <842E78>--|<40A163>|--|I|
  *(m+DE)+M3  : <842E7C>--|<40A185>|--|H|
------------------------------------------------
  *(m+EN)+M1  : <842E84>--|<40A1AB>|--|P|
  *(m+EN)+M2  : <842E88>--|<40A1C4>|--|Y|
  *(m+EN)+M3  : <842E8C>--|<40A1E0>|--|H|
------------------------------------------------
*(*(m+DE)+M1) : <40A140>--|B|
*(*(m+DE)+M2) : <40A163>--|I|
*(*(m+DE)+M3) : <40A185>--|H|
------------------------------------------------
*(*(m+EN)+M1) : <40A1AB>--|P|
*(*(m+EN)+M2) : <40A1C4>--|Y|
*(*(m+EN)+M3) : <40A1E0>--|H|
--------------------------------------------------------
Bojen06: Das war's erstmal!
---------------------------------------------------------- */
