// Datei Enum01.c
// ------------------------------------------------------------------------
#include <stdio.h> // fuer printf und sprintf
#define FARBE enum Farbe
// ------------------------------------------------------------------------
                                // Name(n) des neuen Aufzaehlungs-Typs:
enum Bool   {FALSE, TRUE};      // "enum Bool"
enum Farbe  {ROT, GRUEN, BLAU}; // "enum Farbe"  oder  "FARBE"
// ------------------------------------------------------------------------
enum Bool  b01 = FALSE;
enum Bool  b02 = TRUE;

enum Farbe f01 = ROT;
enum Farbe f02 = BLAU;
FARBE      f03 = GRUEN;
FARBE      f04 = ROT;
// ------------------------------------------------------------------------
FARBE FarbeSucc(FARBE f) {
   // Verlaesst sich darauf, dass f einen Farbe-Code enthaelt.
   // Liefert den Code der naechsten Farbe (zyklisch, nach BLAU kommt ROT)
   if (f==BLAU) return ROT;
   return f+1;
} // FarbeSucc
// ------------------------------------------------------------------------
FARBE FarbePred(FARBE f) {
   // Verlaesst sich darauf, dass f einen Farbe-Code enthaelt.
   // Liefert den Code der vorigen Farbe (zyklisch, nach ROT kommt BLAU)
   if (f==ROT) return BLAU;
   return f-1;
} // FarbePred
// ------------------------------------------------------------------------
static char FehlerMeldung[30];

char * Farbe2String(FARBE f) {
   // Wandelt den Farbe-Code f in einen String mit dem (deutschen) Namen
   // der Farbe um (oder in eine kleine Fehlermeldung, wenn f keinen
   // Farbe-Code enthaelt). Liefert diesen String als Ergebnis.
   switch (f) {
      case ROT:   return "ROT";
      case GRUEN: return "GRUEN";
      case BLAU:  return "BLAU";
      default:
         sprintf(FehlerMeldung, "%d ist keine Farbe!", f);
         return FehlerMeldung;
   } // switch
} // Farbe2String
// ------------------------------------------------------------------------
int main(void) {
   int i;

   enum Bool b03 = FALSE;
   enum Bool b04 = TRUE;

   FARBE     f05 = BLAU;
   FARBE     f06 = ROT;

   printf("-----------------------------------------------------------\n");
   printf("A b01: %d, b02: %d, b03: %d, b04: %d\n", b01, b02, b03, b04);
   printf("B f01: %d, f02: %d, f03: %d, f04: %d\n", f01, f02, f03, f04);
   printf("C f05: %d, f06: %d\n",                   f05, f06);

   f01 = GRUEN;
   f02 = 5;                        // Hier erfolgt KEINE Typpruefung!
   f03 = 2.5;                      // Hier erfolgt KEINE Typpruefung!
   f04 = TRUE;                     // Hier erfolgt KEINE Typpruefung!
   printf("-----------------------------------------------------------\n");
   printf("D f01: %d, f02: %d, f03: %d, f04: %d\n", f01, f02, f03, f04);

   if (f01 == GRUEN) printf("E f01 hat den Wert GRUEN!\n");
   if (f01 <= BLAU)  printf("F f01 ist kleiner oder gleich BLAU!\n");
   if (f01 == TRUE)  printf("G f01 hat den Wert TRUE!\n");
   printf("-----------------------------------------------------------\n");
   printf("H ");
   for (f01=GRUEN, i=1; i<=11; i++) {
      printf("%d ", f01);
      f01=FarbeSucc(f01);
   }
   printf("\n");
   printf("-----------------------------------------------------------\n");
   printf("I ");
   for (f01=ROT; f01<=BLAU+2; f01++) {
      printf("%s | ", Farbe2String(f01));
   }
   printf("\n");
   printf("-----------------------------------------------------------\n");

   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms Enum01:

-----------------------------------------------------------
A b01: 0, b02: 1, b03: 0, b04: 1
B f01: 0, f02: 2, f03: 1, f04: 0
C f05: 2, f06: 0
-----------------------------------------------------------
D f01: 1, f02: 5, f03: 2, f04: 1
E f01 hat den Wert GRUEN!
F f01 ist kleiner oder gleich BLAU!
G f01 hat den Wert TRUE!
-----------------------------------------------------------
H 1 2 0 1 2 0 1 2 0 1 2
-----------------------------------------------------------
I ROT | GRUEN | BLAU | 3 ist keine Farbe! | 4 ist keine Farbe! |
-----------------------------------------------------------
------------------------------------------------------------------------ */
