// Datei Konsole01.c
/* ------------------------------------------------------------------------
Kleiner Test des Moduls Konsole (Konsole.c und Konsole.h)
------------------------------------------------------------------------ */
#include "Konsole.h"
#include <stdio.h>    // fuer sprintf
// ------------------------------------------------------------------------
int main() {

   char  zeichen;
   short virtualKeyCode;
   int   controlKeyStatus;
   char  zeilenNr [30] = " ";
   char  spaltenNr[30] = " ";

   int   z; // Zeile
   int   s; // Spalte
   int   i; // Index fuer for-Schleifen

// COLOR v = BRIGHT_WHITE; // Vordergrundfarbe
   COLOR v;
   COLOR h = BRIGHT_BLUE;  // Hintergrundfarbe
   // ---------------------------------------------------------------------
   // Den Modul Konsole initialisieren:
   initKonsole();

   ClearScreen(BLACK, BRIGHT_WHITE);

   GotoXY(50, 4);
   puts("Hallo1!");
   GotoXY(50, 5);
   puts("Hallo2!");
   GotoXY(50, 6);
   fprintf(stdout, "Hallo3!"); fflush(stdout);
   GotoXY(50, 7);
   printf("Hallo4!"); fflush(stdout);

   PutS(20, 10, "Ein Zeichen?: ");

   // Wo der Cursor steht, ist fuer dieses Programm unwichtig, aber
   // fuer den Benutzer wird unmittelbar hinter die ausgegebene
   // Zeichenkette "Ein Zeichen?:" gesetzt:
   GotoXY(33, 10);

   // Einen beliebigen Tastendruck einlesen (z.B. einen Druck auf
   // eine Zeichentaste, auf eine Umschalttaste, eine Pfeiltaste ...
   // Der Benutzer muss die Eingabe NICHT durch Druecken auf
   // die Return-Taste abschliessen!
   GetImmediateAny(&zeichen, &virtualKeyCode, &controlKeyStatus);

   // Das eingelesene Zeichen an verschiedene Stellen des Bildschirms
   // ausgeben. Eines der Ausgabezeichen erscheint BRIGHT_WHITE auf
   // einem GREEN Hintergrund:
   PutC(10, 11, zeichen);             // Spalte 10, Zeile 11
   PutC(11, 12, zeichen);             // Spalte 11, Zeile 12
   PutC(12, 13, zeichen);             // Spalte 12, Zeile 13
   SetColorsE(
        12, 13, BRIGHT_WHITE, GREEN); // Spalte 12, Zeile 13
   PutC(13, 14, zeichen);             // Spalte 13, Zeile 14
   PutC(14, 15, zeichen);             // Spalte 14, Zeile 15

   // Fuer das Rechteck zwischen Spalte 20 bis 33 und Zeile 11 bis 15
   // Vorder- und Hintergrundfarbe festlegen und mehrfach aendern:
   for (i=0; i<=16; i++) {
      if (h == BRIGHT_WHITE) {
         v = BLACK;
      } else {
         v = BRIGHT_WHITE;
      }
      SetColorsV(20, 33, 11, 15, v, h);
      PutS(20, 12, "                    "); // Loeschen
      PutS(20, 12, ColorName(h));           // Neuer Farbname
//    v = ColorSucc(v);
      h = ColorPred(h);
      GetImmediate(&zeichen);
   }

   // Ein Zeichen einlesen (Umschalttasten, Pfeiltasten etc.
   // werden hier ignoriert):
   GetImmediate(&zeichen);

   // Zwei Zeichen in das farbige Rechteck schreiben:
   PutC(20, 11, 'X'); // Spalte 20, Zeile 11
   PutC(33, 11, 'X'); // Spalte 33, Zeile 11

   GetImmediate(&zeichen);

   // Einen String in das farbige Rechteck schreiben:
   PutS(20, 15, "ABCDEFGHIJKLMN"); // Spalte 20, Zeile 15

   // Ein Zeichen in die Mitte des farbigen Rechtecks schreiben:
   GetImmediate(&zeichen);
   PutC(26, 13, zeichen);

   // Die Anzahl der Zeilen und Spalten aufbereiten und ausgeben:
   sprintf(zeilenNr,  "Anzahl Zeilen:  %d", AnzZeilen());
   sprintf(spaltenNr, "Anzahl Spalten: %d", AnzSpalten());
   PutS(3, 3, zeilenNr);  // Spalte 3, Zeile 3
   PutS(3, 5, spaltenNr); // Spalte 3, Zeile 5

   // Ein Zeichen einlesen:
   GetImmediate(&zeichen);

   // Damit der Bildschirm nach Beendigung dieses Programms wieder
   // "normal" aussieht (und nicht z.B. CYAN auf GREEN):
   ClearScreen(BRIGHT_WHITE, BLACK);

   // Etwa in die Mitte des Fensterpuffers ein Rechteck ausgeben
   // (das zuletzt eingelesene Zeichen wird mehrfach ausgegeben).
   // Wenn der Fensterpuffer groesser ist als das Fenster, sieht
   // der Benutzer erst etwas, wenn er scrollt:
   for (z=AnzZeilen()/4; z<AnzZeilen()/2; z++) {
      for (s=AnzSpalten()/4; s<AnzSpalten()/2; s++) {
         PutC(s, z, zeichen);
      }
   }

   // Nach Beendigung dieses Programms erscheint die Eingabeaufforderung
   // (the prompt) in Zeile 20 (die Spaltenangabe spielt keine Rolle):
   GotoXY(0, 15);

   return 0;
} // main
