// Datei Reihungen01.c
/* ------------------------------------------------------------------------
Reihungen (arrays) mit int-Komponenten werden vereinbart und ausgegeben.
Die Wirkung des Operators sizeof wird demonstriert.

Merke: In C "weiss eine Reihung nicht, wie lang sie ist"!
------------------------------------------------------------------------ */
#include <stdio.h>

#define LENA 5 // Laenge der Reihung ra
#define LENB 3 // Laenge der Reihung rb

int ra[LENA] = {+3, -5, +7, +2, -4};
int rb[LENB] = {-2, +9, -8};
// ------------------------------------------
void gibAus(int rf[], int laenge) {
   // Gibt die Reihung rf in lesbarer Form aus
   int i;
   printf("E sizeof(rf): %d Bytes\n", sizeof(rf));
   printf("F %d Kompos  : ", laenge);
   for (i=0; i<laenge; i++) {
      printf("%d ", rf[i]);
   }
   printf("\n");
} // gibAus
// ------------------------------------------
int main(void) {
   printf("Reihungen01: Jetzt geht es los!\n");
   printf("-------------------------------------\n");
   printf("A sizeof(ra)              : %2d Bytes\n", sizeof(ra));
   printf("B sizeof(rb)              : %2d Bytes\n", sizeof(rb));
   printf("C sizeof(ra)/sizeof(ra[0]): %2d Kompos\n",
             sizeof(ra)/sizeof(ra[0]));
   printf("D sizeof(rb)/sizeof(rb[0]): %2d Kompos\n",
             sizeof(rb)/sizeof(rb[0]));
   printf("-------------------------------------\n");
   gibAus(ra, LENA);
   printf("-------------------------------------\n");
   gibAus(rb, LENB);
   printf("-------------------------------------\n");
   gibAus(rb, LENA);                                    // Oooops!
   printf("-------------------------------------\n");
   return 0;
} // main
// ------------------------------------------
/* ------------------------------------------------------------------------
Ausgabe des Programms Reihungen01:

Reihungen01: Jetzt geht es los!
-------------------------------------
A sizeof(ra)              : 20 Bytes
B sizeof(rb)              : 12 Bytes
C sizeof(ra)/sizeof(ra[0]):  5 Kompos
D sizeof(rb)/sizeof(rb[0]):  3 Kompos
-------------------------------------
E sizeof(rf): 4 Bytes
F 5 Kompos  : 3 -5 7 2 -4
-------------------------------------
E sizeof(rf): 4 Bytes
F 3 Kompos  : -2 9 -8
-------------------------------------
E sizeof(rf): 4 Bytes
F 5 Kompos  : -2 9 -8 168035352 0
-------------------------------------
------------------------------------------------------------------------ */
