// Datei Reihungen02.c
/* ------------------------------------------------------------------------
Reihungen (arrays) mit int-Komponenten werden vereinbart und ausgegeben.
Auf die Komponenten der Reihungen und ihre Adressen wird mit unterschied-
lichen aber gleichbedeutenden Notationen zugegriffen.

Die Variable  ra ist vom Typ "int-Reihung".
Der Parameter rf ist vom Typ "konstanter Zeiger von int".
Diese beiden Typnamen bezeichnen denselben Typ.
------------------------------------------------------------------------ */
#include <stdio.h>

#define LENA 5 // Laenge der Reihung ra
#define LENB 3 // Laenge der Reihung rb

int  ra[LENA] = {+3, -5, +7, +2, -4};
int  rb[LENB] = {-2, +9, -8};
// ------------------------------------------------------------------------
void gibAus(char * name, int * const rf, int len) {
   // Verlaesst sich darauf, dass rf die Adresse einer int-Reihung der
   // Laenge len enthaelt. Gibt jede Komponente dieser Reihung und ihre
   // Adresse dreimal aus (mit unterchiedlichen aber gleichbedeutenden
   // Notationen):

   int i;
   printf("Die Reihung %s hat %d Komponenten:", name, len);
   for (i=0; i<len; i++) {
      printf("\n%s[%d]: ", name, i);
      printf("%2d, ", rf[i]  );    // Notation 1: Reihungsnotation
      printf("%2d, ", *(rf+i));    // Notation 2: Adressnotation
      printf("%2d, ", i[rf]  );    // Notation 3: Verdrehte Reihungsnot.
      printf("Adresse: ");
      printf("%p, ", &rf[i]  );    // Notation 1
      printf("%p, ", &*(rf+i));    // Notation 2
      printf("%p. ", &i[rf]  );    // Notation 3
   }
   printf("\n");
} // gibAus
// ------------------------------------------------------------------------
int main(void) {
   printf("Reihungen02: Jetzt geht es los!\n");
   printf("---------------------------------------------------------\n");
   gibAus("ra", ra, LENA);
   printf("---------------------------------------------------------\n");
   gibAus("rb", rb, LENB);
   printf("---------------------------------------------------------\n");

   return 0;
} // main
// ------------------------------------------
/* ------------------------------------------------------------------------
Ausgabe des Programms Reihungen02:

Reihungen02: Jetzt geht es los!
---------------------------------------------------------
Die Reihung ra hat 5 Komponenten:
ra[0]:  3,  3,  3, Adresse: 0x403010, 0x403010, 0x403010.
ra[1]: -5, -5, -5, Adresse: 0x403014, 0x403014, 0x403014.
ra[2]:  7,  7,  7, Adresse: 0x403018, 0x403018, 0x403018.
ra[3]:  2,  2,  2, Adresse: 0x40301c, 0x40301c, 0x40301c.
ra[4]: -4, -4, -4, Adresse: 0x403020, 0x403020, 0x403020.
---------------------------------------------------------
Die Reihung rb hat 3 Komponenten:
rb[0]: -2, -2, -2, Adresse: 0x403024, 0x403024, 0x403024.
rb[1]:  9,  9,  9, Adresse: 0x403028, 0x403028, 0x403028.
rb[2]: -8, -8, -8, Adresse: 0x40302c, 0x40302c, 0x40302c.
---------------------------------------------------------
------------------------------------------------------------------------ */
