// Datei Reihungen03.c
/* ------------------------------------------------------------------------
Die main-Funktion eines C-Programms kann man wahlweise mit 0 Parametern,
mit 2 Parametern (int, char *) oder mit 3 Parametern (int, char *, char*)
vereinbaren. Ueblicherweise werden die Parameter argv, argc und envp
genannt.

argv bezeichnet eine Reihung von Werten des Typs char * ("String").
argc bezeichnet einen int-Wert, die Laenge der Reihung argv.
envp bezeichnet eine Reihung von Werten des Typs char * ("String").
Die letzte Komponente der Reihung envp hat den Wert NULL.

Die Reihung argv enthaelt die Parameter, die man beim Aufruf des Programms
auf der Kommandozeile angegeben hat (Kommandozeilenparameter).
Die Reihung envp enthaelt die Umgebungsvariablen des Betriebssystems
(z.B. PATH, CLASSPATH, HOME etc.).
------------------------------------------------------------------------ */
#include <stdio.h>
// ------------------------------------------------------------------------
void gibAus1(int anz, char * p[]) {
   // Verlaesst sich darauf, dass p eine Reihung ist, die aus anz vielen
   // Komponenten des Typs char * ("String") besteht. Gibt diese Reihung
   // (eine Komponente pro Zeile) zur Standardausgabe aus:
   int nr;
   for (nr=0; nr<anz; nr++) {
      printf("%2d: %s\n", nr, p[nr]);
   }
} // gibAus1
// ------------------------------------------------------------------------
void gibAus2(char * p[]) {
   // Verlaesst sich darauf, dass p eine Reihung von Komponenten des
   // Typs char * ("String") ist und dass die letzte Komponente den
   // Wert NULL hat. Gibt diese Reihung (eine Komponente pro Zeile)
   // zur Standardausgabe aus:
   int nr = 0;
   while (*p != NULL) {
      printf("%2d: %s\n", ++nr, *p);
      p++;
   }
} // gibAus2
// ------------------------------------------------------------------------
int main(int argc, char * argv[], char * envp[]) {
   printf("Reihungen03: Jetzt geht es los!\n");
   printf("---------------------------------------------------------\n");
   printf("Die Kommandozeilen-Parameter:\n");
   gibAus1(argc, argv);
   printf("---------------------------------------------------------\n");
   printf("Die Umgebungsvariablen:\n");
   gibAus2(envp);
   printf("---------------------------------------------------------\n");

   return 0;
} // main
// ------------------------------------------
/* ------------------------------------------------------------------------
Ausgabe des Programms Reihungen03, nachdem es wie folgt aufgerufen wurde:
> Reihungen03 Hallo 123 Euro "5.25 Kilo"

Reihungen03: Jetzt geht es los!
---------------------------------------------------------
Die Kommandozeilen-Parameter:
 0: Reihungen03
 1: Hallo
 2: 123
 3: Euro
 4: 5.25 Kilo
---------------------------------------------------------
Die Umgebungsvariablen:
 1: !::=::\
 2: !C:=C:\WINDOWS\SYSTEM32
 3: !D:=D:\meineDateien\BspC\Reihungen
 4: !EXITCODE=00000000
 5: ALLUSERSPROFILE=C:\Dokumente und Einstellungen\All Users
...
11: COMSPEC=C:\WINDOWS\system32\cmd.exe
...
19: OS=Windows_NT
20: PATH=/cygdrive/c/WINDOWS/system32:/cygdrive/c/WINDOWS: ...
21: PATHEXT=.COM;.EXE;.BAT;.CMD;.VBS;.VBE;.JS;.JSE;.WSF;.WSH
22: PROCESSOR_ARCHITECTURE=x86
23: PROCESSOR_IDENTIFIER=x86 Family 15 Model 2 Stepping 7, GenuineIntel
...
36: WINDIR=C:\WINDOWS
37: TERM=cygwin
38: HOME=/home/Uli
---------------------------------------------------------
------------------------------------------------------------------------ */
