// Datei Sleep01.c
/* ------------------------------------------------------------------------
Demonstriert die Wirkung der (nicht-Standard) Funktion sleep.
Dabei werden Unterschiede zwischen 3 Compilern mit Hilfe von
Praeprozessor-Anweisungen "ueberbrueckt".
------------------------------------------------------------------------ */
#include <stdio.h>   // E/A in Bytestroeme, printf, sprintf, ...
#include <fenv.h>
#include <inttypes.h>

// Da verschiedene Compiler die Deklaration der sleep-Funktion
// in verschiedenen Kopfdateien haben (in unistd.h, dos.h oder stdlib.h)
// muss hier definiert werden, welcher Compiler (GCC, BCC32 oder
// LCC_WIN32) verwendet wird:
#define GCC

#if   defined GCC
   #include <unistd.h>       // fuer sleep
   #define  ZEITEINHEIT 1    // sleep erwartet Anzahl Sekunden
#elif defined BCC32
   #include <dos.h>          // fuer sleep
   #define  ZEITEINHEIT 1    // sleep erwartet Anzahl Sekunden
#elif defined LCC_WIN32
   #include <stdlib.h>       // fuer sleep
   #define  ZEITEINHEIT 1000 // sleep erwartet Anzahl Millisekunden
#endif
// ------------------------------------------------------------------------
int main(void) {
   int i;

   printf("-----------------------------------------------------------\n");
   printf("Dieses Programm wurde erzeugt mit dem ");
   #if   defined GCC
      printf("Gnu-C-Compiler gcc!\n");
   #elif defined BCC32
      printf("Borland-C-Compiler bcc32!\n");
   #elif defined LCC_WIN32
      printf("C-Compiler lcc-win32!\n");
   #endif
   printf("-----------------------------------------------------------\n");

   printf("Sleep01: Jetzt geht es los!\n");
   printf("-----------------\n");
   for(i=3; i>=-1; i--) {
      printf("Noch %2d Sekunden!\n", i);
      sleep(1 * ZEITEINHEIT);
   }
   printf("Wumm!!!\n");
   printf("-----------------\n");
   printf("Sleep01: Das war's erstmal!\n");
   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms Sleep01:

-----------------------------------------------------------
Dieses Programm wurde erzeugt mit dem Gnu-C-Compiler gcc!
-----------------------------------------------------------
Sleep01: Jetzt geht es los!
-----------------
Noch  3 Sekunden!
Noch  2 Sekunden!
Noch  1 Sekunden!
Noch  0 Sekunden!
Noch -1 Sekunden!
Wumm!!!
-----------------
Sleep01: Das war's erstmal!
------------------------------------------------------------------------ */
