// Datei Zeiger01.c
/* ------------------------------------------------------------------------
Zu jedem Typ T gibt es in C einen Typ T * (Zeiger auf T), z.B.
int * (Zeiger auf int), float * (Zeiger auf float), ... etc.

Eine Variable vom Typ Zeiger auf int hat entweder den Wert NULL (dann
zeigt sie nicht) oder sie zeigt auf eine Variable, die als int-Variable
interpretiert wird. "Mit Gewalt" kann man eine solche Zeigervariable auch
z.B. auf eine float-Variable zeigen lassen, aber dann wird diese Variable
faelschlich als int-Variable interpretiert.

Ganz Entsprechendes gilt fuer eine Variable vom Typ Zeiger auf float etc.
------------------------------------------------------------------------ */
#include <stdio.h>   // E/A in Bytestroeme, printf, sprintf, ...
// ------------------------------------------------------------------------
int     int01 = 1234567890;       // Eine ganz normale   int-Variable
float   flt01 = 1.23456789;       // Eine ganz normale float-Variable

int   * zaii  =           &int01; // Ein Zeiger auf int,   zeigt auf int01
int   * zaif  = (int   *) &flt01; // Ein Zeiger auf int  , zeigt auf flt01
float * zafi  = (float *) &int01; // Ein Zeiger auf float, zeigt auf int01
float * zaff  =           &flt01; // Ein Zeiger auf float, zeigt auf flt01
// ------------------------------------------------------------------------
int main() {
   printf("Zeiger01: Jetzt geht es los!\n");
   printf("------------------------------------\n");
   printf("A                 int01 : %10d\n",
                             int01);
   printf("------------------------------------\n");
   printf("B zaii: %8p, * zaii: %10d\n",
             zaii,      * zaii);
   printf("C zafi: %8p, * zafi: %10.2f\n",
             zafi,      * zafi);
   printf("------------------------------------\n");
   printf("D zaif: %8p, * zaif: %10d\n",
             zaif,      * zaif);
   printf("E zaff: %8p, * zaff: %10.8f\n",
             zaff,      * zaff);
   printf("------------------------------------\n");
   printf("F                 flt01 : %10.8f\n",
                             flt01);
   printf("------------------------------------\n");

   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms Zeiger01:

Zeiger01: Jetzt geht es los!
------------------------------------
A                 int01 : 1234567890
------------------------------------
B zaii: 0x403010, * zaii: 1234567890
C zafi: 0x403010, * zafi: 1228890.25
------------------------------------
D zaif: 0x403014, * zaif: 1067320914
E zaff: 0x403014, * zaff: 1.23456788
------------------------------------
F                 flt01 : 1.23456788
------------------------------------
------------------------------------------------------------------------ */
