// Datei Zeiger02.c
/* ------------------------------------------------------------------------
Erhoeht man eine Adresse-von-short-Variable um 1, so wird sie in
Wirklichkeit um sizeof(short) erhoeht (so dass sie auf die naechste
short-Variable zeigt).

Erhoeht man eine Adresse-von-double-Variable um 1, so wird sie in
Wirklichkeit um sizeof(double) erhoeht (so dass sie auf die naechste
double-Variable zeigt).
------------------------------------------------------------------------ */
#include <stdio.h>   // E/A in Bytestroeme, printf, sprintf, ...
#define LEN 5
// ------------------------------------------------------------------------
short  sr01[LEN] = {111, 222, 333, 444, 555};
double dr01[LEN] = {1.1, 2.2, 3.3, 4.4, 5.5};
int    i;          // Index fuer for-Schleifen
// ------------------------------------------------------------------------
void gibAusSR(short sr[]) {
   // Gibt die Adressen und Werte der Reihungskomponenten sr[i] aus.
   short * avs = &sr[0]; // Adresse von short

   for (i=0; i<LEN; i++) {
      printf("avs: %p, i: %d, avs+i: %p, *(avs+i): %d\n",
              avs,     i,     avs+i,     *(avs+i));
   }
} // gibAusSR
// ------------------------------------------------------------------------
void gibAusDR(double dr[]) {
   // Gibt die Adressen und Werte der Reihungskomponenten dr[i] aus.
   double * avd = &dr[0]; // Adresse von double

   for (i=0; i<LEN; i++) {
      printf("avd: %p, i: %d, avd+i: %p, *(avd+i): %3.1f\n",
              avd,     i,     avd+i,     *(avd+i));
   }
} // gibAusDR
// ------------------------------------------------------------------------
int main() {
   printf("Zeiger02: Jetzt geht es los!\n");
   printf("---------------------------------------------------\n");
   printf("sizeof(short) : %d Bytes\n", sizeof(short));
   printf("sizeof(double): %d Bytes\n", sizeof(double));
   printf("---------------------------------------------------\n");
   gibAusSR(sr01);
   printf("---------------------------------------------------\n");
   gibAusDR(dr01);
   printf("---------------------------------------------------\n");

   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms Zeiger02:

Zeiger02: Jetzt geht es los!
---------------------------------------------------
sizeof(short) : 2 Bytes
sizeof(double): 8 Bytes
---------------------------------------------------
avs: 0040A128, i: 0, avs+i: 0040A128, *(avs+i): 111
avs: 0040A128, i: 1, avs+i: 0040A12A, *(avs+i): 222
avs: 0040A128, i: 2, avs+i: 0040A12C, *(avs+i): 333
avs: 0040A128, i: 3, avs+i: 0040A12E, *(avs+i): 444
avs: 0040A128, i: 4, avs+i: 0040A130, *(avs+i): 555
---------------------------------------------------
avd: 0040A134, i: 0, avd+i: 0040A134, *(avd+i): 1.1
avd: 0040A134, i: 1, avd+i: 0040A13C, *(avd+i): 2.2
avd: 0040A134, i: 2, avd+i: 0040A144, *(avd+i): 3.3
avd: 0040A134, i: 3, avd+i: 0040A14C, *(avd+i): 4.4
avd: 0040A134, i: 4, avd+i: 0040A154, *(avd+i): 5.5
---------------------------------------------------
------------------------------------------------------------------------ */
