// Datei Zeiger04.c
/* ------------------------------------------------------------------------
Der Adressoperator & und der Variablenoperator ("Derefenzierungsoperator")
* heben sich gegenseitig auf.

Eine sinnvolle Anwendung von Adresstypen:
Parameter von Adresstypen machen es moeglich, dass eine Funktion ihren
Aufrufern mehrere Ergebnisse zur Verfuegung stellt (statt nur ein Ergebnis
zu liefern).
------------------------------------------------------------------------ */
void berechne(int a, int b, int *s, int *d, int *p) {
   // Berechnet die Summe, die Differenz und das Produkt von a und b
   // und bringt sie in die Variablen *s, *d bzw. *p.
   *s = a + b;
   *d = a - b;
   *p = a * b;
} // berechne
// ------------------------------------------------------------------------
int main() {
   // Eine normale Variable und eine Adressvariable:
   long    g01 = 17;
   long * ag01 = &g01;

   // Einzelne Variablen als Parameter fuer berechne:
   int n1 = 23;
   int n2 = 11;

   int summ;
   int diff;
   int prod;

   // Reihungen von Variablen als Parameter fuer berech:
   #define LEN 3

   int N1  [LEN] = {30, 45, 51};
   int N2  [LEN] = {25, 15, 20};

   int Summ[LEN];
   int Diff[LEN];
   int Prod[LEN];

   int i; // Index fuer for-Schleifen

   printf("Zeiger04: Jetzt geht es los!\n");

   // Warum einfach, wenn es auch kompliziert geht?
   // Der Adressoperator & und der Variablenoperator * heben
   // sich gegenseitig auf:
   printf("-----------------------------------------------\n");
   printf("Der Adressoperator    & und                    \n");
   printf("der Variablenoperator * heben sich             \n");
   printf("gegenseitig auf (*& und &* \"machen nix\"):  \n\n");

   printf("A   g01: %d,   ag01: %p\n",   g01,   ag01);
   printf("B *&g01: %d, &*ag01: %p\n", *&g01, &*ag01);

   // berechne einmal aufrufen und die 3 Ergebnisse ausgeben:
   printf("-----------------------------------------------\n");
   berechne(n1, n2, &summ, &diff, &prod);
   printf("C n1: %d, n2: %d, summ: %d, diff: %d, prod: %d\n",
             n1,     n2,     summ,     diff,     prod);

   for (i=0; i<LEN; i++) {
      // berechne mehrmals aufrufen und die jeweils 3 Ergebniss
      // in den Reihungen Summ, Diff und Prod speichern:
      berechne(N1[i], N2[i], &Summ[i], &Diff[i], &Prod[i]);
   }

   // Die Reihungen N1, N2, Summ, Diff und Prod lesbar ausgeben:
   printf("-----------------------------------------------\n");
   printf("D N1[i]  N2[i]  Summ[i]  Diff[i]  Prod[i]\n");
   for (i=0; i<LEN; i++) {
      printf("E %5d  %5d  %7d  %7d  %7d\n",
         N1[i], N2[i], Summ[i], Diff[i], Prod[i]);
   }
   printf("-----------------------------------------------\n");

   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms Zeiger01:

Zeiger04: Jetzt geht es los!
-----------------------------------------------
Der Adressoperator    & und
der Variablenoperator * heben sich
gegenseitig auf (*& und &* "machen nix"):

A   g01: 17,   ag01: 0x22fed4
B *&g01: 17, &*ag01: 0x22fed4
-----------------------------------------------
C n1: 23, n2: 11, summ: 34, diff: 12, prod: 253
-----------------------------------------------
D N1[i]  N2[i]  Summ[i]  Diff[i]  Prod[i]
E    30     25       55        5      750
E    45     15       60       30      675
E    51     20       71       31     1020
-----------------------------------------------
------------------------------------------------------------------------ */
