// Datei Zeiger06.c
/* ------------------------------------------------------------------------
In C haben auch Funktionen Adressen, die man in Variablen speichern kann.
------------------------------------------------------------------------ */
#include <stdio.h>   // E/A in Bytestroeme, printf, sprintf, ...


void gibAus1(int n) {
   printf("gibAus1: n hat den Wert   %d\n", n);
} // gibAus1

void gibAus2(int n) {
   printf("gibAus2: n has the value  %d\n", n);
} // gibAus1

void gibAus3(int n) {
   printf("gibAus3: n tiene el valor %d\n", n);
} // gibAus1

// Namen fuer einen Funktionstyp und einen Adresstyp vereinbaren:
typedef void ft1(int);
typedef ft1* aft1;

// Zum Typ ft1 gehoeren alle Funktionen mit dem Rueckgabetyp void und
// einem int-Parameter (z.B. die Funktionen gibAus1 bis gibAus3).
// Zum Typ aft1 gehoeren der Wert NULL und alle Adressen von Funktionen
// des Typs ft1 (z.B. die Adressen &gibAus1 bis &gibAus3).

// Alternativ haette man den Adresstyp aft1 auch "direkt" (ohne den
// Hilfstyp ft1) wie folgt vereinbaren koennen:
// typedef void (*aft1) (int);

aft1 funk   = gibAus1;
aft1 tab[3] = {gibAus1, gibAus2, gibAus3};
// ------------------------------------------------------------------------
int main() {
   int i;

   printf("Zeiger06: Jetzt geht es los!\n");
   printf("---------------------------\n");

   // Die Funktion, der Adresse in der Variablen funk steht, wird
   // aufgerufen:
   funk(5);

   // Der Wert der Adressvariablen funk wird veraendert:
   funk = gibAus2;

   // Die Funktion, deren Adresse jetzt in der Variablen funk steht,
   // wird aufgerufen:
   funk(3);

   printf("---------------------------\n");
   // Die Funktionen, deren Adressen in der Reihung tab stehen,
   // werden der Reihe nach aufgerufen:
   for (i=0; i<3; i++) {
      tab[i](3*i + 2);
   }
   printf("---------------------------\n");

   return 0;
} // main
/* ------------------------------------------------------------------------
Ausgabe des Programms Zeiger06:

Zeiger06: Jetzt geht es los!
---------------------------
gibAus1: n hat den Wert   5
gibAus2: n has the value  3
---------------------------
gibAus1: n hat den Wert   2
gibAus2: n has the value  5
gibAus3: n tiene el valor 8
---------------------------
------------------------------------------------------------------------ */
